Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/EvaluationCache.cs
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/EvaluationCache.cs	(revision 6195)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/EvaluationCache.cs	(revision 6195)
@@ -0,0 +1,302 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ * 
+ * The LRU cache is based on an idea by Robert Rossney see 
+ * <http://csharp-lru-cache.googlecode.com>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+namespace HeuristicLab.Problems.ExternalEvaluation {
+
+  [Item("EvaluationCache", "Cache for external evaluation values")]
+  [StorableClass]
+  public class EvaluationCache : ParameterizedNamedItem {
+
+    #region Types
+    private class CacheEntry {
+
+      public string Key { get; private set; }
+      public double Value { get; set; }
+
+      public CacheEntry(string key, double value) {
+        Key = key;
+        Value = value;
+      }
+
+      public CacheEntry(string key) : this(key, 0) { }
+
+      public override bool Equals(object obj) {
+        CacheEntry other = obj as CacheEntry;
+        if (other == null)
+          return false;
+        return Key.Equals(other.Key);
+      }
+
+      public override int GetHashCode() {
+        return Key.GetHashCode();
+      }
+
+      public override string ToString() {
+        return string.Format("{{{0} : {1}}}", Key, Value);
+      }
+    }
+
+    public delegate double Evaluator(SolutionMessage message);
+    #endregion
+
+    #region Fields
+    private LinkedList<CacheEntry> list;
+    private Dictionary<CacheEntry, LinkedListNode<CacheEntry>> index;
+    private HashSet<string> activeEvaluations = new HashSet<string>();
+    private object cacheLock = new object();
+    private object evaluationLock = new object();
+    private AutoResetEvent evaluationDone = new AutoResetEvent(false);
+    #endregion
+
+    #region Properties
+    public override System.Drawing.Image ItemImage {
+      get { return VSImageLibrary.Database; }
+    }
+    public int Size {
+      get {
+        lock (cacheLock) {
+          return index.Count;
+        }
+      }
+    }
+    public int ActiveEvaluations {
+      get {
+        lock (evaluationLock) {
+          return activeEvaluations.Count;
+        }
+      }
+    }
+    [Storable]
+    public int Hits { get; private set; }
+    #endregion
+
+    #region events
+    public event EventHandler SizeChanged;
+    public event EventHandler HitsChanged;
+    public event EventHandler ActiveEvalutionsChanged;
+
+    protected virtual void OnSizeChanged() {
+      EventHandler handler = SizeChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    protected virtual void OnHitsChanged() {
+      EventHandler handler = HitsChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    protected virtual void OnActiveEvalutionsChanged() {
+      EventHandler handler = ActiveEvalutionsChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    #endregion
+
+    #region Parameters
+    public FixedValueParameter<IntValue> CapacityParameter {
+      get { return (FixedValueParameter<IntValue>)Parameters["Capacity"]; }
+    }
+    public FixedValueParameter<BoolValue> PersistentCacheParameter {
+      get { return (FixedValueParameter<BoolValue>)Parameters["PersistentCache"]; }
+    }
+    #endregion
+
+    #region Parameter Values
+    public int Capacity {
+      get { return CapacityParameter.Value.Value; }
+      set { CapacityParameter.Value.Value = value; }
+    }
+    public bool IsPersistent {
+      get { return PersistentCacheParameter.Value.Value; }
+    }
+    #endregion
+
+    #region Persistence
+    [Storable(Name="Cache")]
+    private IEnumerable<KeyValuePair<string, double>> Cache_Persistence {
+      get {
+        if (IsPersistent) {
+          return GetCacheValues();
+        } else {
+          return Enumerable.Empty<KeyValuePair<string, double>>();
+        }
+      }
+      set {
+        SetCacheValues(value);
+      }
+    }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEvents();
+    }
+    #endregion
+
+    #region Construction & Cloning
+    [StorableConstructor]
+    protected EvaluationCache(bool deserializing) : base(deserializing) { }
+    protected EvaluationCache(EvaluationCache original, Cloner cloner)
+      : base(original, cloner) {
+      SetCacheValues(original.GetCacheValues());
+      RegisterEvents();
+    }
+    public EvaluationCache() {
+      list = new LinkedList<CacheEntry>();
+      index = new Dictionary<CacheEntry, LinkedListNode<CacheEntry>>();
+      Parameters.Add(new FixedValueParameter<IntValue>("Capacity", "Maximum number of cache entries.", new IntValue(10000)));
+      Parameters.Add(new FixedValueParameter<BoolValue>("PersistentCache", "Save cache when serializing object graph?", new BoolValue(false)));
+      RegisterEvents();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EvaluationCache(this, cloner);
+    }
+    #endregion
+
+    #region Event Handling
+    private void RegisterEvents() {
+      CapacityParameter.Value.ValueChanged += new EventHandler(Value_ValueChanged);
+    }
+
+    void Value_ValueChanged(object sender, EventArgs e) {
+      if (Capacity < 0)
+        throw new ArgumentOutOfRangeException("Cache capacity cannot be less than zero");
+      Trim();
+    }
+    #endregion
+
+    #region Methods
+    public void Reset() {
+      lock (cacheLock) {
+        list = new LinkedList<CacheEntry>();
+        index = new Dictionary<CacheEntry, LinkedListNode<CacheEntry>>();
+        Hits = 0;
+      }
+      OnSizeChanged();
+      OnHitsChanged();
+    }
+
+    public double GetValue(SolutionMessage message, Evaluator evaluate) {
+      CacheEntry entry = new CacheEntry(message.ToString());
+      LinkedListNode<CacheEntry> node;
+      bool lockTaken = false;
+      try {
+        Monitor.Enter(cacheLock, ref lockTaken);
+        if (index.TryGetValue(entry, out node)) {
+          list.Remove(node);
+          list.AddLast(node);
+          Hits++;
+          lockTaken = false;
+          Monitor.Exit(cacheLock);
+          OnHitsChanged();
+          return node.Value.Value;
+        } else {
+          lockTaken = false;
+          Monitor.Exit(cacheLock);
+          return Evaluate(message, evaluate, entry);
+        }
+      } finally {
+        if (lockTaken)
+          Monitor.Exit(cacheLock);
+      }
+    }
+
+    private double Evaluate(SolutionMessage message, Evaluator evaluate, CacheEntry entry) {
+      bool lockTaken = false;
+      try {
+        Monitor.Enter(evaluationLock, ref lockTaken);
+        if (activeEvaluations.Contains(entry.Key)) {
+          while (activeEvaluations.Contains(entry.Key)) {
+            lockTaken = false;
+            Monitor.Exit(evaluationLock);
+            evaluationDone.WaitOne();
+            Monitor.Enter(evaluationLock, ref lockTaken);
+          }
+          lock (cacheLock) {
+            return index[entry].Value.Value;
+          }
+        } else {
+          activeEvaluations.Add(entry.Key);
+          lockTaken = false;
+          Monitor.Exit(evaluationLock);
+          OnActiveEvalutionsChanged();
+          try {
+            entry.Value = evaluate(message);
+            lock (cacheLock) {
+              index[entry] = list.AddLast(entry);
+            }
+            Trim();
+          } finally {
+            lock (evaluationLock) {
+              activeEvaluations.Remove(entry.Key);
+              evaluationDone.Set();
+            }
+            OnActiveEvalutionsChanged();
+          }
+          return entry.Value;
+        }
+      } finally {
+        if (lockTaken)
+          Monitor.Exit(evaluationLock);
+      }
+    }
+
+    private void Trim() {
+      lock (cacheLock) {
+        while (list.Count > Capacity) {
+          LinkedListNode<CacheEntry> item = list.First;
+          list.Remove(item);
+          index.Remove(item.Value);
+        }
+      }
+      OnSizeChanged();
+    }
+    private IEnumerable<KeyValuePair<string, double>> GetCacheValues() {
+      lock (cacheLock) {
+        return index.ToDictionary(kvp => kvp.Key.Key, kvp => kvp.Key.Value);
+      }
+    }
+    private void SetCacheValues(IEnumerable<KeyValuePair<string, double>> value) {
+      lock (cacheLock) {
+        list = new LinkedList<CacheEntry>();
+        index = new Dictionary<CacheEntry, LinkedListNode<CacheEntry>>();
+        foreach (var kvp in value) {
+          var entry = new CacheEntry(kvp.Key);
+          entry.Value = kvp.Value;
+          index[entry] = list.AddLast(entry);
+        }
+      }
+    }
+    #endregion
+
+  }
+}
Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationProblem.cs
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationProblem.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationProblem.cs	(revision 6195)
@@ -53,6 +53,6 @@
 
     #region Parameters
-    public IValueParameter<IEvaluationServiceClient> ClientParameter {
-      get { return (IValueParameter<IEvaluationServiceClient>)Parameters["Client"]; }
+    public IValueParameter<CheckedItemCollection<IEvaluationServiceClient>> ClientsParameter {
+      get { return (IValueParameter<CheckedItemCollection<IEvaluationServiceClient>>)Parameters["Clients"]; }
     }
     public IValueParameter<IExternalEvaluationProblemEvaluator> EvaluatorParameter {
@@ -85,4 +85,7 @@
     public ValueParameter<ItemList<IOperator>> OperatorsParameter {
       get { return (ValueParameter<ItemList<IOperator>>)Parameters["Operators"]; }
+    }
+    public OptionalValueParameter<EvaluationCache> CacheParameter {
+      get { return (OptionalValueParameter<EvaluationCache>)Parameters["Cache"]; }
     }
     #endregion
@@ -141,5 +144,5 @@
       UserDefinedSolutionCreator solutionCreator = new UserDefinedSolutionCreator();
 
-      Parameters.Add(new ValueParameter<IEvaluationServiceClient>("Client", "The client that is used to communicate with the external application.", new EvaluationServiceClient()));
+      Parameters.Add(new ValueParameter<CheckedItemCollection<IEvaluationServiceClient>>("Clients", "The clients that are used to communicate with the external application.", new CheckedItemCollection<IEvaluationServiceClient>() { new EvaluationServiceClient() }));
       Parameters.Add(new ValueParameter<IExternalEvaluationProblemEvaluator>("Evaluator", "The evaluator that collects the values to exchange.", evaluator));
       Parameters.Add(new ValueParameter<ISolutionCreator>("SolutionCreator", "An operator to create the solution components.", solutionCreator));
@@ -148,7 +151,23 @@
       Parameters.Add(new OptionalValueParameter<IScope>("BestKnownSolution", "The best known solution for this external evaluation problem."));
       Parameters.Add(new ValueParameter<ItemList<IOperator>>("Operators", "The operators that are passed to the algorithm.", new ItemList<IOperator>()));
+      Parameters.Add(new OptionalValueParameter<EvaluationCache>("Cache", "Cache of previously evaluated solutions."));
 
       InitializeOperators();
       AttachEventHandlers();
+    }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code, remove with 3.4
+      if (!Parameters.ContainsKey("Clients")) {
+        Parameters.Add(new ValueParameter<CheckedItemCollection<IEvaluationServiceClient>>("Clients", "The clients that are used to communicate with the external application.", new CheckedItemCollection<IEvaluationServiceClient>() { new EvaluationServiceClient() }));
+        if (Parameters.ContainsKey("Client")) {
+          var client = ((IValueParameter<IEvaluationServiceClient>)Parameters["Client"]).Value;
+          if (client != null)
+            ClientsParameter.Value = new CheckedItemCollection<IEvaluationServiceClient>() { client };
+          Parameters.Remove("Client");
+        }
+      }
+      #endregion
     }
 
@@ -223,5 +242,5 @@
     }
     private void ParameterizeEvaluator() {
-      Evaluator.ClientParameter.ActualName = ClientParameter.Name;
+      Evaluator.ClientsParameter.ActualName = ClientsParameter.Name;
     }
     private void ParameterizeOperators() {
Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluator.cs
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluator.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluator.cs	(revision 6195)
@@ -21,4 +21,7 @@
 
 using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -32,50 +35,66 @@
   [StorableClass]
   public class ExternalEvaluator : ValuesCollector, IExternalEvaluationProblemEvaluator {
+
+    #region Parameters
     public ILookupParameter<DoubleValue> QualityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public IValueLookupParameter<IEvaluationServiceClient> ClientParameter {
-      get { return (IValueLookupParameter<IEvaluationServiceClient>)Parameters["Client"]; }
+    public IValueLookupParameter<CheckedItemCollection<IEvaluationServiceClient>> ClientsParameter {
+      get { return (ValueLookupParameter<CheckedItemCollection<IEvaluationServiceClient>>)Parameters["Clients"]; }
     }
-
     public IValueParameter<SolutionMessageBuilder> MessageBuilderParameter {
       get { return (IValueParameter<SolutionMessageBuilder>)Parameters["MessageBuilder"]; }
     }
+    #endregion
 
-    private SolutionMessageBuilder MessageBuilder {
+    #region Parameter Values
+    protected SolutionMessageBuilder MessageBuilder {
       get { return MessageBuilderParameter.Value; }
     }
+    protected CheckedItemCollection<IEvaluationServiceClient> Clients {
+      get { return ClientsParameter.ActualValue; }
+    }
+    #endregion
 
+    #region Fields
+    protected HashSet<IEvaluationServiceClient> activeClients = new HashSet<IEvaluationServiceClient>();
+    protected object clientLock = new object();
+    protected AutoResetEvent clientAvailable = new AutoResetEvent(false);
+    #endregion
+
+    #region Construction & Cloning
     [StorableConstructor]
     protected ExternalEvaluator(bool deserializing) : base(deserializing) { }
     protected ExternalEvaluator(ExternalEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public ExternalEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the current solution."));
+      Parameters.Add(new ValueLookupParameter<CheckedItemCollection<IEvaluationServiceClient>>("Clients", "Collection of clients which communicate the the external process. These clients my be contacted in parallel."));
+      Parameters.Add(new ValueParameter<SolutionMessageBuilder>("MessageBuilder", "The message builder that converts from HeuristicLab objects to SolutionMessage representation.", new SolutionMessageBuilder()));
+    }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new ExternalEvaluator(this, cloner);
     }
-    public ExternalEvaluator()
-      : base() {
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the current solution."));
-      Parameters.Add(new ValueLookupParameter<IEvaluationServiceClient>("Client", "The client that communicates with the external process."));
-      Parameters.Add(new ValueParameter<SolutionMessageBuilder>("MessageBuilder", "The message builder that converts from HeuristicLab objects to SolutionMessage representation.", new SolutionMessageBuilder()));
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code, remove with 3.4
+      if (!Parameters.ContainsKey("Clients")) {
+        Parameters.Add(new ValueLookupParameter<CheckedItemCollection<IEvaluationServiceClient>>("Clients", "Collection of clients which communicate the the external process. These clients my be contacted in parallel."));
+        if (Parameters.ContainsKey("Client")) {
+          var client = ((IValueLookupParameter<IEvaluationServiceClient>)Parameters["Client"]).Value;
+          if (client != null)
+            ClientsParameter.Value = new CheckedItemCollection<IEvaluationServiceClient>() { client };
+          Parameters.Remove("Client");
+        }
+      }
+      #endregion
     }
+    #endregion
 
     public override IOperation Apply() {
-      IEvaluationServiceClient client = ClientParameter.ActualValue;
-      SolutionMessage.Builder protobufBuilder = SolutionMessage.CreateBuilder();
-      protobufBuilder.SolutionId = 0;
-      foreach (IParameter param in CollectedValues) {
-        IItem value = param.ActualValue;
-        if (value != null) {
-          ILookupParameter lookupParam = param as ILookupParameter;
-          string name = lookupParam != null ? lookupParam.TranslatedName : param.Name;
-          try {
-            MessageBuilder.AddToMessage(value, name, protobufBuilder);
-          }
-          catch (ArgumentException ex) {
-            throw new InvalidOperationException("ERROR in " + Name + ": Parameter " + name + " cannot be added to the message.", ex);
-          }
-        }
-      }
-      QualityMessage answer = client.Evaluate(protobufBuilder.Build());
+
+      QualityMessage answer = EvaluateOnNextAvailableClient(BuildSolutionMessage());
+
       if (QualityParameter.ActualValue == null)
         QualityParameter.ActualValue = new DoubleValue(answer.Quality);
@@ -84,4 +103,48 @@
       return base.Apply();
     }
+
+    protected QualityMessage EvaluateOnNextAvailableClient(SolutionMessage message) {
+      IEvaluationServiceClient client = null;
+      lock (clientLock) {
+        client = Clients.CheckedItems.FirstOrDefault(c => !activeClients.Contains(c));
+        while (client == null && Clients.Count > 0) {
+          Monitor.Exit(clientLock);
+          clientAvailable.WaitOne();
+          Monitor.Enter(clientLock);
+          client = Clients.CheckedItems.FirstOrDefault(c => !activeClients.Contains(c));
+        }
+        if (client != null)
+          activeClients.Add(client);
+      }
+      try {
+        return client.Evaluate(message);
+      } finally {
+        lock (clientLock) {
+          activeClients.Remove(client);
+          clientAvailable.Set();
+        }
+      }
+    }
+
+    protected SolutionMessage BuildSolutionMessage() {
+      lock (clientLock) {
+        SolutionMessage.Builder protobufBuilder = SolutionMessage.CreateBuilder();
+        protobufBuilder.SolutionId = 0;
+        foreach (IParameter param in CollectedValues) {
+          IItem value = param.ActualValue;
+          if (value != null) {
+            ILookupParameter lookupParam = param as ILookupParameter;
+            string name = lookupParam != null ? lookupParam.TranslatedName : param.Name;
+            try {
+              MessageBuilder.AddToMessage(value, name, protobufBuilder);
+            } catch (ArgumentException ex) {
+              throw new InvalidOperationException(string.Format("ERROR while building solution message: Parameter {0} cannot be added to the message", name), ex);
+            }
+          }
+        }
+        return protobufBuilder.Build();
+      }
+    }
+
   }
 }
Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/HeuristicLab.Problems.ExternalEvaluation-3.3.csproj
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/HeuristicLab.Problems.ExternalEvaluation-3.3.csproj	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/HeuristicLab.Problems.ExternalEvaluation-3.3.csproj	(revision 6195)
@@ -98,4 +98,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -115,4 +116,6 @@
     <Compile Include="Converters\IntegerConverter.cs" />
     <Compile Include="Converters\StringConverter.cs" />
+    <Compile Include="CachedExternalEvaluator.cs" />
+    <Compile Include="EvaluationCache.cs" />
     <Compile Include="Drivers\EvaluationServiceClient.cs" />
     <Compile Include="Drivers\EvaluationChannel.cs" />
@@ -150,4 +153,8 @@
       <Name>HeuristicLab.Common-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
+      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
+      <Name>HeuristicLab.Core.Views-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
       <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
@@ -165,4 +172,12 @@
       <Project>{6908BDCE-D925-43F3-94AC-A531E6DF2591}</Project>
       <Name>ProtocolBuffers</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
+      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
+      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
+      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
+      <Name>HeuristicLab.MainForm-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/HeuristicLabProblemsExternalEvaluationPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/HeuristicLabProblemsExternalEvaluationPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/HeuristicLabProblemsExternalEvaluationPlugin.cs.frame	(revision 6195)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.ExternalEvaluation {
-  [Plugin("HeuristicLab.Problems.ExternalEvaluation", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.ExternalEvaluation", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.ExternalEvaluation-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/Interfaces/IExternalEvaluationProblemEvaluator.cs
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/Interfaces/IExternalEvaluationProblemEvaluator.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/Interfaces/IExternalEvaluationProblemEvaluator.cs	(revision 6195)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Problems.ExternalEvaluation {
   public interface IExternalEvaluationProblemEvaluator : ISingleObjectiveEvaluator {
-    IValueLookupParameter<IEvaluationServiceClient> ClientParameter { get; }
+    IValueLookupParameter<CheckedItemCollection<IEvaluationServiceClient>> ClientsParameter { get; }
   }
 }
Index: branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.ExternalEvaluation/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -34,3 +34,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Problems.Knapsack.Views/3.3/HeuristicLabProblemsKnapsackViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.Knapsack.Views/3.3/HeuristicLabProblemsKnapsackViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.Knapsack.Views/3.3/HeuristicLabProblemsKnapsackViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.Knapsack.Views plugin
   /// </summary>
-  [Plugin("HeuristicLab.Problems.Knapsack.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.Knapsack.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Knapsack.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core", "3.3")]
Index: branches/histogram/HeuristicLab.Problems.Knapsack.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.Knapsack.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.Knapsack.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Problems.Knapsack/3.3/HeuristicLabProblemsKnapsackPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.Knapsack/3.3/HeuristicLabProblemsKnapsackPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.Knapsack/3.3/HeuristicLabProblemsKnapsackPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.Knapsack plugin
   /// </summary>
-  [Plugin("HeuristicLab.Problems.Knapsack", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.Knapsack", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Knapsack-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Problems.Knapsack/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.Knapsack/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.Knapsack/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLabProblemsOneMaxViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLabProblemsOneMaxViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.OneMax.Views/3.3/HeuristicLabProblemsOneMaxViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.OneMax.Views plugin
   /// </summary>
-  [Plugin("HeuristicLab.Problems.OneMax.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.OneMax.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.OneMax.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/histogram/HeuristicLab.Problems.OneMax.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.OneMax.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.OneMax.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Problems.OneMax/3.3/HeuristicLabProblemsOneMaxPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.OneMax/3.3/HeuristicLabProblemsOneMaxPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.OneMax/3.3/HeuristicLabProblemsOneMaxPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.OneMax plugin
   /// </summary>
-  [Plugin("HeuristicLab.Problems.OneMax", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.OneMax", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.OneMax-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Problems.OneMax/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.OneMax/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.OneMax/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Plugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Plugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Plugin.cs.frame	(revision 6195)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.QuadraticAssignment.Views {
-  [Plugin("HeuristicLab.Problems.QuadraticAssignment.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Problems.QuadraticAssignment.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.QuadraticAssignment.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
